#include <stdlib.h>
#include <stdio.h>

#include "cmd_proc.h"

#define PRUM_PROUD 	2061
#define PRUM_SOUC	6183

/**
 * \brief
 * Commands detection.
 */
void poll_cmd(struct rpi_state* state){
	unsigned int tmp;
	/*
	 * Note:
	 * pri pouziti scanf("%u",&simple_hall_duty); dochazelo
	 * k preukladani hodnot na promenne test. Dost divne.
	 */
	while (1){
		scanf("%u",&tmp);
		printf("volba=%u\n",tmp);
		switch (tmp){
		case 1:
			scanf("%u",&tmp);
			sem_wait(&state->thd_par_sem);
			state->pwm1=tmp&0xFFF;
			sem_post(&state->thd_par_sem);
			break;
		case 2:
			scanf("%u",&tmp);
			sem_wait(&state->thd_par_sem);
			state->pwm2=tmp&0xFFF;
			sem_post(&state->thd_par_sem);
			break;
		case 3:
			scanf("%u",&tmp);
			sem_wait(&state->thd_par_sem);
			state->pwm3=tmp&0xFFF;
			sem_post(&state->thd_par_sem);
			break;
		case 4:
			scanf("%u",&tmp);
			sem_wait(&state->thd_par_sem);
			state->test=tmp&0xFF;
			sem_post(&state->thd_par_sem);
			break;
		case 5:
			sem_wait(&state->thd_par_sem);
			state->commutate=!state->commutate;
			/* switch off pwms at the end of commutation */
			state->pwm1&=state->commutate*0xFFFF;
			state->pwm2&=state->commutate*0xFFFF;
			state->pwm3&=state->commutate*0xFFFF;
			sem_post(&state->thd_par_sem);
			break;
		case 6:
			scanf("%d",&tmp);
			sem_wait(&state->thd_par_sem);
			state->duty=tmp;
			sem_post(&state->thd_par_sem);
			break;
		case 7:
			scanf("%d",&tmp);
			sem_wait(&state->thd_par_sem);
			state->desired_pos=tmp;
			sem_post(&state->thd_par_sem);
			break;

		default:
			break;
		}

	}
	return ;
}
/*
 * pocita procentualni odchylku od prumerneho proudu
 */
float diff_p(float value){
	return ((float)value-PRUM_PROUD)*100/PRUM_PROUD;
}
/*
 * pocita procentualni odchylku od prumerneho souctu proudu
 */
float diff_s(float value){
	return ((float)value-PRUM_SOUC)*100/PRUM_SOUC;
}

/*
 * tiskne potrebna data
 */
void printData(struct rpi_state* state){
	struct rpi_in data_p;
	struct rpi_state s;	/*state*/
	float cur0, cur1, cur2;
	int i;
	/* copy the data */
	sem_wait(&state->thd_par_sem);
	data_p = *state->spi_dat;
	s=*state;
	sem_post(&state->thd_par_sem);

	if (data_p.adc_m_count){
		cur0=data_p.ch0/data_p.adc_m_count;
		cur1=data_p.ch1/data_p.adc_m_count;
		cur2=data_p.ch2/data_p.adc_m_count;
	}
	for (i = 0; i < 16; i++) {
			if (!(i % 6))
				puts("");
			printf("%.2X ", data_p.debug_rx[i]);
	}
	puts("");
	printf("\npozice=%d\n",(int32_t)data_p.pozice);
	printf("chtena pozice=%d\n",s.desired_pos);
	printf("transfer count=%u\n",s.tf_count);
	printf("raw_pozice=%u\n",data_p.pozice_raw);
	printf("raw_pozice last12=%u\n",(data_p.pozice_raw&0x0FFF));
	printf("index position=%u\n",data_p.index_position);
	printf("hal1=%d, hal2=%d, hal3=%d\n",data_p.hal1,data_p.hal2,data_p.hal3);
	printf("en1=%d, en2=%d, en3=%d (Last sent)\n",!!(0x40&s.test),!!(0x20&s.test),!!(0x10&s.test));
	printf("shdn1=%d, shdn2=%d, shdn3=%d (L.s.)\n",!!(0x08&s.test),!!(0x04&s.test),!!(0x02&s.test));
	printf("PWM1=%u(L.s.)\n",s.pwm1);
	printf("PWM2=%u(L.s.)\n",s.pwm2);
	printf("PWM3=%u(L.s.)\n",s.pwm3);
	printf("distance to index=%u\n",s.index_dist);
	printf("T_PWM1=%u T_PWM2=%u T_PWM3=%u\n",s.t_pwm1,s.t_pwm2, s.t_pwm3);
	printf("Pocet namerenych proudu=%u\n",data_p.adc_m_count);
	printf("(pwm1) (ch1)=%d (avg=%4.0f) (%2.2f%%)\n",data_p.ch1,cur1,diff_p(cur1));
	printf("(pwm2) (ch2)=%d (avg=%4.0f)(%2.2f%%)\n",data_p.ch2,cur2,diff_p(cur2));
	printf("(pwm3) (ch0)=%d (avg=%4.0f)(%2.2f%%)\n",data_p.ch0,cur0,diff_p(cur0));
	printf("soucet prumeru=%5.0f (%2.2f%%)\n",cur0+cur1+cur2,diff_s(cur0+cur1+cur2));
	printf("duty=%d\n",s.duty);
	if (s.index_ok) printf("index ok\n");
	if (s.commutate) printf("commutation in progress\n");
}
